/*
** File: dpc.c  
** Project: VxWorks Driver Framework
** Purpose: Deferred procedure call stub (using isrDeferLib)
**
** (C) Copyright Alpha Data 2010
*/

#include "df.h"
#include "dfvxworks.h"

void
_dfVxwIsrDeferStub(
  void* pContext)
{
  DfDpc* pDpc = (DfDpc*)pContext;

  pDpc->system.pFunction(pDpc, pDpc->system.pContext, pDpc->system.pArg);
  if (dfAtomicDec(&pDpc->system.refCount) == 0) {
    dfEventSignal(pDpc->system.pEvent);
  }
}

void
_dfVxwExcJobStub(
  int arg1, /* pDpc */
  int arg2, /* pArg passed to dfDpcSchedule */
  int arg3,
  int arg4,
  int arg5,
  int arg6)
{
  DfDpc* pDpc = (DfDpc*)arg1;

  pDpc->system.pFunction(pDpc, pDpc->system.pContext, (void*)arg2);
  if (dfAtomicDec(&pDpc->system.refCount) == 0) {
    dfEventSignal(pDpc->system.pEvent);
  }
}
